<?php
namespace Bushelpowered\Api\Businesspages\V1\Model;
        
class StaffDiscountScheduleDetail 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $name The name of the discount schedule.*/
    public string $name;
    /** @var string[] $locationIds The ids of the Associated Tenant Service Locations.*/
    public array $locationIds;
    /** @var bool $isPublic An indicator of the discount schedule's public availability.*/
    public bool $isPublic;
    /** @var null|string $notes Notes about the discount schedule.*/
    public ?string $notes = null;
    /** @var string $fileLink The link to the file associated with the discount schedule.*/
    public string $fileLink;
    /** @var null|string $publishedAt The date and time the business location was published (viewable by growers). of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $publishedAt = null;
    /** @var string $createdAt The date and time the business location was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt The date and time the business location was updated. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $name The name of the discount schedule.
     * @param  string[]  $locationIds The ids of the Associated Tenant Service Locations.
     * @param  bool  $isPublic An indicator of the discount schedule's public availability.
     * @param  null|string  $notes Notes about the discount schedule.
     * @param  string  $fileLink The link to the file associated with the discount schedule.
     * @param  null|string  $publishedAt The date and time the business location was published (viewable by growers). of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt The date and time the business location was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt The date and time the business location was updated. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $name, array $locationIds, bool $isPublic, ?string $notes, string $fileLink, ?string $publishedAt, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->name = $name;
        $this->locationIds = $locationIds;
        $this->isPublic = $isPublic;
        $this->notes = $notes;
        $this->fileLink = $fileLink;
        $this->publishedAt = $publishedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    

}