<?php
namespace Bushelpowered\Api\Businesspages\V1\Request;
        
class StaffCreateSpecialtyProgramFileRequest 
{
    /** @var null|string $displayName Display name according to the file service, business page service will ignore this in favor of its own display name. If null we will use the fileName.*/
    public ?string $displayName = null;
    /** @var \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramFileType $fileType */
    public \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramFileType $fileType;
    /** @var string $fileName The name of the file as it was stored on the users computer. This will never be displayed to the user. Just stored in the file service.*/
    public string $fileName;
    /** @var string $file Base64 encoded. Limit of 5MB*/
    public string $file;

    /**
     * @param  null|string  $displayName Display name according to the file service, business page service will ignore this in favor of its own display name. If null we will use the fileName.
     * @param  \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramFileType  $fileType 
     * @param  string  $fileName The name of the file as it was stored on the users computer. This will never be displayed to the user. Just stored in the file service.
     * @param  string  $file Base64 encoded. Limit of 5MB
     */
    public function __construct(?string $displayName, \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramFileType $fileType, string $fileName, string $file)
    {
        $this->displayName = $displayName;
        $this->fileType = $fileType;
        $this->fileName = $fileName;
        $this->file = $file;
    }
    

}