<?php
namespace Bushelpowered\Api\Businesspages\V1\Request;
        
class StaffCreateSpecialtyProgramRequest 
{
    /** @var string $title The title of the specialty program. Limit of 50 characters*/
    public string $title;
    /** @var bool $isPublic Whether the specialty program is public.*/
    public bool $isPublic;
    /** @var null|string $headerImageId The id of the header image that was returned by the StaffCreateSpecialtyProgramFile call*/
    public ?string $headerImageId = null;
    /** @var null|string $filesTitle The title of the file. Limit of 25 characters*/
    public ?string $filesTitle = null;
    /** @var \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramParagraphRequest[] $paragraphs The content that will be displayed on the specialty program. Limit of 5.*/
    public array $paragraphs;
    /** @var \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramAssociateFileRequest[] $files The files that will be linked to the specialty program. Limit 50*/
    public array $files;

    /**
     * @param  string  $title The title of the specialty program. Limit of 50 characters
     * @param  bool  $isPublic Whether the specialty program is public.
     * @param  null|string  $headerImageId The id of the header image that was returned by the StaffCreateSpecialtyProgramFile call
     * @param  null|string  $filesTitle The title of the file. Limit of 25 characters
     * @param  \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramParagraphRequest[]  $paragraphs The content that will be displayed on the specialty program. Limit of 5.
     * @param  \Bushelpowered\Api\Businesspages\V1\Request\SpecialtyProgramAssociateFileRequest[]  $files The files that will be linked to the specialty program. Limit 50
     */
    public function __construct(string $title, bool $isPublic, ?string $headerImageId, ?string $filesTitle, array $paragraphs, array $files)
    {
        $this->title = $title;
        $this->isPublic = $isPublic;
        $this->headerImageId = $headerImageId;
        $this->filesTitle = $filesTitle;
        $this->paragraphs = $paragraphs;
        $this->files = $files;
    }
    

}