<?php
namespace Bushelpowered\Api\Iam\Keycloak\V1\Response;
        
class User implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp
{
    /** @var string $id The id of the user, sometimes called bushel_id.*/
    public string $id;
    /** @var null|string $firstName The first name of the user*/
    public ?string $firstName = null;
    /** @var null|string $lastName The last name of the user*/
    public ?string $lastName = null;
    /** @var null|string $email The email address of the user*/
    public ?string $email = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;

    /**
     * @param  string  $id The id of the user, sometimes called bushel_id.
     * @param  null|string  $firstName The first name of the user
     * @param  null|string  $lastName The last name of the user
     * @param  null|string  $email The email address of the user
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, ?string $firstName, ?string $lastName, ?string $email, string $createdAt)
    {
        $this->id = $id;
        $this->firstName = $firstName;
        $this->lastName = $lastName;
        $this->email = $email;
        $this->createdAt = $createdAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
}