<?php
namespace Bushelpowered\Api\Platform\Authorization\V1\Event;
        
class IdentifierRoles 
{
    /** @var string $userIdpId The identifier for the user in the specified IDP*/
    public string $userIdpId;
    /** @var string $idpSlug The slug that specifies which identity provider should be used to authenticate this account binding.*/
    public string $idpSlug;
    /** @var null|string $name The name of the user that this identifies.*/
    public ?string $name = null;
    /** @var string[]|null $roles The IDs of the roles to provide for this IdentifierAccount. If the roles property is null, the default role will be assumed.*/
    public ?array $roles = null;

    /**
     * @param  string  $userIdpId The identifier for the user in the specified IDP
     * @param  string  $idpSlug The slug that specifies which identity provider should be used to authenticate this account binding.
     * @param  null|string  $name The name of the user that this identifies.
     * @param  string[]|null  $roles The IDs of the roles to provide for this IdentifierAccount. If the roles property is null, the default role will be assumed.
     */
    public function __construct(string $userIdpId, string $idpSlug, ?string $name, ?array $roles)
    {
        $this->userIdpId = $userIdpId;
        $this->idpSlug = $idpSlug;
        $this->name = $name;
        $this->roles = $roles;
    }
    

}