<?php
namespace Bushelpowered\Api\Platform\Commodity\V1\Request;
        
class CreateOrUpdateTenantCommodityRequest 
{
    /** @var string $datasourceId The datasource identifier.*/
    public string $datasourceId;
    /** @var null|string $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.*/
    public ?string $integrationId = null;
    /** @var string $sourceId The source record identifier.*/
    public string $sourceId;
    /** @var null|string $sourceDisplayName The display name coming from the datasource.*/
    public ?string $sourceDisplayName = null;
    /** @var null|string $displayName The display name.*/
    public ?string $displayName = null;
    /** @var null|string $commodityVarietyId The standard commodity variety Id*/
    public ?string $commodityVarietyId = null;
    /** @var null|string $defaultUom Specifies the default unit of measure for the commodity’s quantities, used when no other unit of measure is provided.*/
    public ?string $defaultUom = null;

    /**
     * @param  string  $datasourceId The datasource identifier.
     * @param  null|string  $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.
     * @param  string  $sourceId The source record identifier.
     * @param  null|string  $sourceDisplayName The display name coming from the datasource.
     * @param  null|string  $displayName The display name.
     * @param  null|string  $commodityVarietyId The standard commodity variety Id
     * @param  null|string  $defaultUom Specifies the default unit of measure for the commodity’s quantities, used when no other unit of measure is provided.
     */
    public function __construct(string $datasourceId, ?string $integrationId, string $sourceId, ?string $sourceDisplayName, ?string $displayName, ?string $commodityVarietyId, ?string $defaultUom)
    {
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceDisplayName = $sourceDisplayName;
        $this->displayName = $displayName;
        $this->commodityVarietyId = $commodityVarietyId;
        $this->defaultUom = $defaultUom;
    }
    

}