<?php
namespace Bushelpowered\Api\Platform\File\V1\Common;
        
class IncludeFileUrlsOption implements \Bushelpowered\Api\Platform\File\V1\Common\HasFileUrlOptions
{
    /** @var int $validFor The number of seconds the url is valid for. Max 604800.*/
    public int $validFor;
    /** @var null|\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition $contentDisposition */
    public ?\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition $contentDisposition = null;

    /**
     * @param  int  $validFor The number of seconds the url is valid for. Max 604800.
     * @param  null|\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition  $contentDisposition 
     */
    public function __construct(int $validFor, ?\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition $contentDisposition)
    {
        $this->validFor = $validFor;
        $this->contentDisposition = $contentDisposition;
    }
    
    /**
     * @return int The number of seconds the url is valid for. Max 604800.
     */
    public function getValidFor(): int
    {
        return $this->validFor;
    }
    /**
     * @return null|\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition 
     */
    public function getContentDisposition(): ?\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition
    {
        return $this->contentDisposition;
    }
}