<?php
namespace Bushelpowered\Api\Platform\File\V1\Common;
        
class Validations 
{
    /** @var string[]|null $allowedContentTypes The allowed IANA media types (mime types). e.g. image/png, image/jpeg*/
    public ?array $allowedContentTypes = null;
    /** @var null|bool $clean Scan the file for malicious content*/
    public ?bool $clean = null;
    /** @var null|int $maxSize The max file size in bytes*/
    public ?int $maxSize = null;

    /**
     * @param  string[]|null  $allowedContentTypes The allowed IANA media types (mime types). e.g. image/png, image/jpeg
     * @param  null|bool  $clean Scan the file for malicious content
     * @param  null|int  $maxSize The max file size in bytes
     */
    public function __construct(?array $allowedContentTypes, ?bool $clean, ?int $maxSize)
    {
        $this->allowedContentTypes = $allowedContentTypes;
        $this->clean = $clean;
        $this->maxSize = $maxSize;
    }
    

}