<?php
namespace Bushelpowered\Api\Platform\Tenant\V1\Request;
        
class GetAllAccountsRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var string[]|null $ids */
    public ?array $ids = null;
    /** @var string[]|null $tenantIds */
    public ?array $tenantIds = null;
    /** @var string[]|null $integrationIds */
    public ?array $integrationIds = null;
    /** @var null|string $name Fuzzy search on sourceName and name. The input is split by spaces, and all parts must match (AND logic) for a result to be returned.*/
    public ?string $name = null;
    /** @var null|\Bushelpowered\Api\Platform\Tenant\V1\Request\AccountPagination $pagination */
    public ?\Bushelpowered\Api\Platform\Tenant\V1\Request\AccountPagination $pagination = null;

    /**
     * @param  string[]|null  $ids 
     * @param  string[]|null  $tenantIds 
     * @param  string[]|null  $integrationIds 
     * @param  null|string  $name Fuzzy search on sourceName and name. The input is split by spaces, and all parts must match (AND logic) for a result to be returned.
     * @param  null|\Bushelpowered\Api\Platform\Tenant\V1\Request\AccountPagination  $pagination 
     */
    public function __construct(?array $ids, ?array $tenantIds, ?array $integrationIds, ?string $name, ?\Bushelpowered\Api\Platform\Tenant\V1\Request\AccountPagination $pagination)
    {
        $this->ids = $ids;
        $this->tenantIds = $tenantIds;
        $this->integrationIds = $integrationIds;
        $this->name = $name;
        $this->pagination = $pagination;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Platform\Tenant\V1\Request\AccountPagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Platform\Tenant\V1\Request\AccountPagination
    {
        return $this->pagination;
    }
}