<?php
namespace Bushelpowered\Api\Platform\User\V1\Request;
        
class GetAllStaffUsersRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var string[]|null $ids */
    public ?array $ids = null;
    /** @var null|string $search Combined case-insensitive search on name, email, and job title using OR logic to match records containing the specified keyword anywhere in the fields. A maximum of two words or phrases, separated by either a space or a comma, is allowed; exceeding this limit will result in a Constraint Violation (e.g., "John Smith" is valid, but "John Michael Smith" is not). To search these fields individually, use the specific `name`, `email`, or `jobTitle` request options.*/
    public ?string $search = null;
    /** @var null|string $name Case-insensitive search on first and last names, split by spaces or commas. Each part must match in either the first or last name fields, and all parts must be present for a result to match (e.g., searching "John Smith" only returns records containing "John" and "Smith" in either field)*/
    public ?string $name = null;
    /** @var null|string $email Case-insensitive search on email to match records containing the specified keyword anywhere within the field.*/
    public ?string $email = null;
    /** @var null|string $jobTitle Case-insensitive search on job title for the specified tenant to find records containing the keyword anywhere within the field. Job titles are staff-specific and only searched within the given tenant.*/
    public ?string $jobTitle = null;
    /** @var null|\Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserPagination $pagination */
    public ?\Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserPagination $pagination = null;

    /**
     * @param  string[]|null  $ids 
     * @param  null|string  $search Combined case-insensitive search on name, email, and job title using OR logic to match records containing the specified keyword anywhere in the fields. A maximum of two words or phrases, separated by either a space or a comma, is allowed; exceeding this limit will result in a Constraint Violation (e.g., "John Smith" is valid, but "John Michael Smith" is not). To search these fields individually, use the specific `name`, `email`, or `jobTitle` request options.
     * @param  null|string  $name Case-insensitive search on first and last names, split by spaces or commas. Each part must match in either the first or last name fields, and all parts must be present for a result to match (e.g., searching "John Smith" only returns records containing "John" and "Smith" in either field)
     * @param  null|string  $email Case-insensitive search on email to match records containing the specified keyword anywhere within the field.
     * @param  null|string  $jobTitle Case-insensitive search on job title for the specified tenant to find records containing the keyword anywhere within the field. Job titles are staff-specific and only searched within the given tenant.
     * @param  null|\Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserPagination  $pagination 
     */
    public function __construct(?array $ids, ?string $search, ?string $name, ?string $email, ?string $jobTitle, ?\Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserPagination $pagination)
    {
        $this->ids = $ids;
        $this->search = $search;
        $this->name = $name;
        $this->email = $email;
        $this->jobTitle = $jobTitle;
        $this->pagination = $pagination;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserPagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserPagination
    {
        return $this->pagination;
    }
}