<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Model;
        
class PublicBidCropStandard 
{
    /** @var string $id The id of the cash bid group*/
    public string $id;
    /** @var string $name The name of the crop, e.g. 'Wheat Cash'*/
    public string $name;
    /** @var string $marketTickSize The number that represents the market default's precision of the bid price e.g. 0.0025 means it rounds to the nearest quarter cent.*/
    public string $marketTickSize;
    /** @var \Bushelpowered\Api\Trade\Futures\V1\Model\BidStandard[] $bids The list of bids for the crop*/
    public array $bids;

    /**
     * @param  string  $id The id of the cash bid group
     * @param  string  $name The name of the crop, e.g. 'Wheat Cash'
     * @param  string  $marketTickSize The number that represents the market default's precision of the bid price e.g. 0.0025 means it rounds to the nearest quarter cent.
     * @param  \Bushelpowered\Api\Trade\Futures\V1\Model\BidStandard[]  $bids The list of bids for the crop
     */
    public function __construct(string $id, string $name, string $marketTickSize, array $bids)
    {
        $this->id = $id;
        $this->name = $name;
        $this->marketTickSize = $marketTickSize;
        $this->bids = $bids;
    }
    

}